#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>
#include <time.h>

#define DPI 6.283185307
#define MPI 1.5707963
#define BASE 1
#define ANTEBRAZO 2
#define BRAZO 3
#define PINZA 4
#define DEDO 5
#define CAJA  6
#define CAJA2  7
#define TODO  8
#define PAPELERA  9
#define CINTA 10
#define EJES 11


#define TIME 5000
int cuenta=0;


float D=150.0;
static GLfloat view_rotx=20.0, view_roty=30.0, view_rotz=0.0;

static int		menu;     // Identificador del menu
//typedef enum{ ZOOM,GIRAR,TODO,BASE,ANTEBRAZO,BRAZO,PINZA,SALIR} opciones_menu;

#define ZOOM         12
#define GIRAR        13
#define SALIR        14


typedef enum {MOVIENDO,GIRANDO} acciones_raton;
int MODORaton=MOVIENDO;
int RatonPulsado = GL_FALSE;



int Xref=0, Yref=0;
int anchoX=0,altoY=0;
int objeto=TODO;


int Complex=200;

int ang1=0;
int ang2=0;
int ang3=0;
float apertura=1.5;
float lon=0;
float z=0.05;

int cajeta = 0;
float D_cinta = 0;
float caida  = -1.5;
int stop=0;

int etapa=0;
int pausa=10;

void CreaListas();

void Resetea(){
ang1=0;
ang2=0;
ang3=0;
apertura=1.5;
lon=0;
z=0.05;

cajeta = 0;
D_cinta = 0;
caida  = -1.5;

etapa=0;
pausa=10;

}

static void caja( GLfloat x, GLfloat y, GLfloat z )
/* Construye una caja con un vertice en origen y otro en (x,y,z)
*/
{


   /* Caras transversales */
   glBegin( GL_QUAD_STRIP );{
      glNormal3f( 0.0, 0.0, -1.0 );   /* Vertical hacia atras */

   

      glVertex3f( x, 0, 0 );
      glVertex3f( 0, 0, 0 );


      glVertex3f( x, y, 0 );
      glVertex3f( 0, y, 0 );

glNormal3f( 0.0, 1.0, 0.0 );       /* Superior, horizontal */




      glVertex3f( x, y, z );
      glVertex3f( 0, y, z );
glNormal3f( 0.0, 0.0, 1.0 );       /*Vertical delantera*/

     

      glVertex3f( x, 0, z );
      glVertex3f( 0, 0, z );

glNormal3f( 0.0, -1.0, 0.0 );       /*Inferior */

    

      glVertex3f( x, 0, 0 );
      glVertex3f( 0, 0, 0 );  }
    glEnd();

   /* Costados */
   glBegin( GL_QUADS );{
      glNormal3f( 1.0, 0.0, 0.0 );

      glVertex3f( x, 0, 0 );
      glVertex3f( x, y, 0 );
      glVertex3f( x, y, z );
      glVertex3f( x, 0, z ); }
   glEnd();

   glBegin( GL_QUADS );{
      glNormal3f( -1.0, 0.0, 0.0 );
  

      glVertex3f( 0, 0, 0 );
      glVertex3f( 0, 0, z );
      glVertex3f( 0, y, z );
      glVertex3f( 0, y, 0 ); }
   glEnd();


}
static void circulo(GLfloat r,int n){
  register int i;
  double f;

  glBegin( GL_POLYGON);
  for (i=0;i<n;i++)
    {
      glNormal3f( 0.0, 1, 0.0 );
      f=(DPI/n)*i;
      glVertex3f(r*sin(f),0,r*cos(f));
    }
  glEnd();
}
static void tubo( GLfloat h, GLfloat r1, GLfloat r2,int n){
register int i;
register double f,s,c;
double y;

y=r1-r2;


glBegin( GL_QUAD_STRIP);
   for (i=0;i<=n;i++)
     {
       f=-(DPI/n)*i;
       s=sin(f);
       c=cos(f);
       glNormal3f( h*s, y, h*c );
       glVertex3f(r1*s,0,r1*c);
       glVertex3f(r2*s,h,r2*c);
     }
   glEnd();

}

/*
dibuja una semiesfera
 */
void semiesfera (GLfloat r,int n){
register int i,j;
register double f,s,c;
double f2,s2,c2,r1,h1;
double f3,s3,c3,r2,h2;

 for (i=0;i<n;i++){
   f2=(MPI/n)*i;
   s2=sin(f2);
   c2=cos(f2);
   f3=(MPI/n)*(i+1);
   s3=sin(f3);
   c3=cos(f3);

   r1=c2*r;
   r2=c3*r;
   h1=s2*r;
   h2=s3*r;
   glBegin( GL_QUAD_STRIP);
   for (j=0;j<=n;j++)
     {
       f=-(DPI/n)*j;
       s=sin(f);
       c=cos(f);
       glNormal3f(r1*s,h1,r1*c);
       glVertex3f(r1*s,h1,r1*c);
       glNormal3f(r2*s,h2,r2*c);
       glVertex3f(r2*s,h2,r2*c);
       
     }
   glEnd();
 }
}

/*
dibuja una esfera
 */
void esfera (GLfloat r,int n){
  semiesfera (r, n);
  glPushMatrix();
  glRotatef(180,0,0,1);
  semiesfera (r, n);
  glPopMatrix();
}


void brazo(void){
  glPushMatrix();

  glRotatef(ang2,0,1,0);/*el angulo de giro*/
  glCallList (BASE);
  glPushMatrix();
  glTranslatef(0,7,0);/*subimos el brazo hasta el centro de la esfera (punto de giro)*/
  glRotatef(ang1,1,0,0);/*el angulo de inclinacion*/
  glTranslatef(0,sqrt(pow(2.5,2)-pow(0.6,2)),0);/*lo subimos hasta el borde de la cupula*/
  glCallList (ANTEBRAZO);/*el 1 segmento del brazo*/
  glTranslatef(0,10+sqrt(pow(1.2,2)-pow(0.6,2)),0);/*subimos hasta el codo*/
  glRotatef(120-ang1,1,0,0);/*rotamos para que mantenga el angulo*/
  glTranslatef(0,sqrt(pow(1.2,2)-pow(0.6,2)),0);/*subimos hasta el borde de la esfera*/
  glCallList (BRAZO);/*la parte final del brazo*/
  glTranslatef(0,10+sqrt(pow(1.2,2)-pow(1,2)),0);
  glRotatef(60,1,0,0);/*completamos el giro de 180*/
  glRotatef(ang3,0,1,0);/*giro de la pinza*/
 
  glCallList(PINZA);
  /*si la cajeta esta en la pinza la dibujamos*/
  if (cajeta){
    glCallList(CAJA);
  }

  /*los "dedos" de la pinza*/
  glPushMatrix();
  glTranslatef(1.5-apertura,0,0);
  glCallList(DEDO);
  glPopMatrix();

  glPushMatrix();
  glTranslatef(2+apertura,0,0);
  glCallList(DEDO);
  glPopMatrix();


  glPopMatrix();
  glPopMatrix();
 
}

void cinta(void){
  int i;


  glPushMatrix();
  glTranslatef(0,3,0);

  /*la cinta transportadora*/
  glCallList(CINTA);


  /*la distancia del brazo*/
  glTranslatef(D_cinta-1,0,20.2);
 
  /*la fila de xajas*/
  for (i=0;i<20;i++){
    glCallList(CAJA2);
    glTranslatef(9,0,0);
  }
  glPopMatrix();


  /*caja que cae*/
  if (caida>0.5){
    glPushMatrix();
    glTranslatef(-1,caida,-11.1);
    glCallList(CAJA2);
    glPopMatrix();
  }

  /*el lugar donde cae*/
  glCallList(PAPELERA);
}

void base (void){
  glPushMatrix();
  glRotatef(ang2,0,1,0);
  glCallList (BASE);
  glPopMatrix();
}

void antebrazo (void){
  glPushMatrix();

  glRotatef(ang1,1,0,0);
  glTranslatef(0,sqrt(pow(2.5,2)-pow(0.6,2)),0);
  glCallList (ANTEBRAZO);

  glPopMatrix();
}

void pinza (void){
  glPushMatrix();
  glRotatef(ang3,0,1,0);
 
  glCallList(PINZA);
  if (cajeta)
    glCallList(CAJA);
  glPushMatrix();
  glTranslatef(1.5-apertura,0,0);
  glCallList(DEDO);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(2+apertura,0,0);
  glCallList(DEDO);
  glPopMatrix();

  glPopMatrix();
 
}

static void Dibuja( void )
{
  static GLfloat pos[4] = {5.0, 5.0, 10.0, 0.0 };

  glPushMatrix();		// Apila la transformacin geomtrica actual

  // Fija el color de fondo a negro
  glClearColor(0,0,0,1);

  // Inicializa el buffer de color
  glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT );


  // Fija el color de dibujo

  // Introduce la geometria

       glLightfv( GL_LIGHT0, GL_POSITION, pos );
     
       glTranslatef(0,0,-D);
 	
       glRotatef( view_rotx, 1.0, 0.0, 0.0 );
       glRotatef( view_roty, 0.0, 1.0, 0.0 );
       glRotatef( view_rotz, 0.0, 0.0, 1.0 );



       glCallList(EJES);
   
	switch (objeto){
	case  BASE :  base(); break ;
	case  ANTEBRAZO  :  antebrazo(); break ;
	case  BRAZO  :  brazo ();  break ;
	case  PINZA : pinza(); break ;
	case  CINTA :  cinta(); break ;
	case  TODO : brazo (); cinta(); break ;
	}
	
	glPopMatrix(); // Desapila la transformacin geomtrica
  	
	//glFlush();  Fuerza el dibujo de las primitivas introducidas
	glutSwapBuffers();


}
/* ------------------------------------------------------------------------- */

void Ventana(GLsizei ancho,GLsizei alto)
{
	float calto; 	// altura de la ventana corregida
  // Establecemos el Viewport usando la nueva anchura y altura de la ventana X
  	glViewport(0,0,ancho,alto);

	anchoX=ancho;
	altoY=alto;

 // Especificamos la transformacin de visualizacin 	
  	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	

  	if(ancho>0)
  		calto = 1*(GLfloat)alto/(GLfloat)ancho;
  	else
  		calto = 1;
  		
	glFrustum(-1,1,-calto,calto,5,250);

// A partir de este momento las transformaciones son de modelado  		
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();


}

/* -------------------- FUNCIONES DE INTERACCIN ----------------------------------- */
 static void letra (unsigned char k, int x, int y)
{
  switch (k) {
  case 'h':
  case 'H':
  	printf("\n C.A.D. 						Curso 2000-2001");
  	printf("\n Practica 2 de DAC");
  	printf("\n E.T.S.I. Informtica		Univ. de Granada ");
  	printf("\n Teclas:");
  	printf("\n Flechas rotar eje X e Y.");
	printf("\n z y Z rotar en el eje Z.");
	printf("\n + - Zoom in out.");
	printf("\n 1-2 amuenta-disminuye n de poligonos.");
	printf("\n 3-4 Sombreado-poligonos planos.");
	printf("\n X Pausa.");
	printf("\n Teclas para el modo pausa:");
	printf("\n Q-W Baja-Levanta el brazo.");
	printf("\n E-R Giran el brazo.");
	printf("\n A-S Abren-Cierran la pinza.");
	printf("\n D-F Giran la pinza.");
	printf("\n ");
  	printf("\n Escape: Salir");
  	printf("\n");
  	break;
  case 'z':
    view_rotz += 5.0;
    break;
  case '+':
    D -= 5.0;
    break;
  case '-':
    D += 5.0;
    break;
  case 'Z':
    view_rotz -= 5.0;
    break;
  case '1':
    Complex+=5;
    printf("Complejidad: %d\n",Complex);
    CreaListas();
    break;
  case '2':
    Complex-=5;
    printf("Complejidad: %d\n",Complex);
    CreaListas();
    break;
  case '3':
    glShadeModel( GL_SMOOTH );
    printf("Sombreado activado.\n");
    break;
  case '4':
    glShadeModel( GL_FLAT );
    printf("Poligonos planos.\n");
    break;
  case 'Q':
  case 'q':
    if (stop)
      if (ang1<55)
	ang1+=5;
    break;
  case 'W':
  case 'w':
    if (stop)
      if (ang1>0)
	ang1-=5;
    break;
  case 'A':
  case 'a':
    if (stop)
      if(apertura<1.5)
	apertura+=0.5;
    break;
  case 'S':
  case 's':
    if (stop){
      if(cajeta){
	if(apertura>1)
	  apertura-=0.5;
      }
      else
	if(apertura>0)
	  apertura-=0.5;
    }
    break;
  case 'E':
  case 'e':
    if (stop)
      ang2+=5;
    break;
  case 'R':
  case 'r':
    if (stop)
      ang2-=5;
    break;
  case 'D':
  case 'd':
    if (stop)
      ang3+=5;
    break;
  case 'F':
  case 'f':
    if (stop)
      ang3-=5;
    break;
  case 'X':
  case 'x':
    if (stop)
      Resetea();
    stop=!stop;
    break;
 
  case 27:  /* Escape */
    exit(0);
    break;
  default:
    return;
  }
  glutPostRedisplay();
}



 static void especial(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    view_rotx += 5.0;
    break;
  case GLUT_KEY_DOWN:
    view_rotx -= 5.0;
    break;
  case GLUT_KEY_LEFT:
    view_roty += 5.0;
    break;
  case GLUT_KEY_RIGHT:
    view_roty -= 5.0;
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

 void seleccionMenu( int opcion )
{
   switch ( opcion )
   {
   case ZOOM:
      MODORaton=MOVIENDO;
      break;
   case GIRAR:
      MODORaton=GIRANDO;
      break;
   case TODO:
     objeto=TODO;
     glutPostRedisplay();
     break;
   case BASE:
     objeto=BASE;
     glutPostRedisplay();
     break;
   case BRAZO:
     objeto=BRAZO;
     glutPostRedisplay();
     break;
   case ANTEBRAZO:
     objeto=ANTEBRAZO;
     glutPostRedisplay();
     break;
   case PINZA:
     objeto=PINZA;
     glutPostRedisplay();
     break;
   case CINTA:
     objeto=CINTA;
     glutPostRedisplay();
     break;
   case SALIR:
   	  exit(0);
   }
}

static void RatonMovido( int x, int y );

void clickRaton( int boton, int estado, int x, int y )
{
	
   	if(boton== GLUT_LEFT_BUTTON && estado == GLUT_DOWN) {
   		if( ~(RatonPulsado)){
      		Xref=x;
      		Yref=y;
      		RatonPulsado=GL_TRUE;
      		RatonMovido (x,y);
      		}
      	}
	else RatonPulsado=GL_FALSE;

}



 static void RatonMovido( int x, int y )
 // Esta funcin mueve la camara por el escenario
/**/ // Dependiendo del modo mueve o gira la camara
{
if(RatonPulsado)     {
	//printf("_");
	if(MODORaton==MOVIENDO) {
	  if (y>altoY/2)
	    D += 5.0;
	  else
	    D -= 5.0;
	    }
	else{
	  /*view_rotx += (Yref -y-150) / 10;
   		view_roty += (Xref -x-150) / 10;*/
	  if ((x>anchoX/3)&&(x<2*anchoX/3)){
	    if (y>altoY/2)
	      view_rotx += 10;
	    else
	      view_rotx -= 10;
	  }
	  else
	    if (x>anchoX/2)
	      view_roty -= 10;
	    else
	      view_roty += 10;
	}
	glutPostRedisplay();
	}
}



 void CreaMenu()
{

   menu = glutCreateMenu( seleccionMenu );

   glutAddMenuEntry( "Zoom", ZOOM );
   glutAddMenuEntry( "Girar", GIRAR );
   glutAddMenuEntry( "Todo", TODO );
   glutAddMenuEntry( "Base", BASE );
   glutAddMenuEntry( "Brazo", BRAZO );
   glutAddMenuEntry( "Antebrazo", ANTEBRAZO );
   glutAddMenuEntry( "Pinza", PINZA );
   glutAddMenuEntry( "Cinta", CINTA );
   glutAddMenuEntry( "Salir", SALIR );

   MODORaton = MOVIENDO;

   glutAttachMenu( GLUT_RIGHT_BUTTON );
   glutMouseFunc( clickRaton );
 
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_CULL_FACE);
   glEnable( GL_LIGHTING );
   glEnable( GL_LIGHT0 );
   glEnable (GL_NORMALIZE);

   glShadeModel( GL_SMOOTH );

}






static void animacion()
{
  cuenta++;

  if(!stop){
    switch (etapa){
    case 0 : 
      if (ang1<55)
	ang1+=5;
      else
	etapa=1;
      break;
    case 1 :
      if(apertura>1)
	apertura-=0.5;
      else{
	etapa = 2;
	D_cinta=9;/*coje la cajeta*/
	cajeta=1;
      }
      break;
    case 2:
      if(pausa>0)
	pausa--;
      else{
	pausa=10;
	etapa=3;
      }
      break;

    case 3 :
      if (ang1>0)
	ang1-=5;
      else
	etapa = 4;
    case 4:
      if(pausa>0)
	pausa--;
      else{
	pausa=10;
	etapa=5;
      }
      break;
    case 5 :
      if (ang2<180){
	ang2+=5;
	if (D_cinta>0)
	  D_cinta-=0.25;
      }
      else
	etapa = 6;
      break;
    case 6 :
      if(apertura<1.5)
	apertura+=0.5;
      else{
	etapa = 7;
	/*suelta la cajeta*/
	cajeta=0;
	caida=8.5;
      }
    case 7:
      if(pausa>0){
	pausa--;
	caida-=0.85;
      }
      else{
	pausa=10;
	caida-=0.85;
	etapa=8;
      }
      break;
    case 8 :
      if (ang2>0){
	ang2-=5;
      }
      else{
	etapa = 0;
      }
    }
    glutPostRedisplay(); 
  }


}


static void animacion2(int v){
  //animacion();
  printf ("FPS: %g\n",(float)(cuenta/5));
  //printf ("%d\n",time(NULL));
  cuenta=0;
  glutTimerFunc( TIME,animacion2,1 );
}


void tira(tira){
  glBegin( GL_POLYGON);
      glNormal3f( 0.0, 0.0, -1 );   /* Vertical hacia atras */
      glVertex3f( 0, 5, 0 );
      glVertex3f( 200, 5, 0 );
      glVertex3f( 200, 0, 0 );
      glVertex3f( 0, 0, 0 );

      glEnd();
}

void CreaListas(){

  float  color1[]={1.0,0.0,0.1,0.3,0.5},
         color2[]={1.0,0.5,0.0,0.3,0.5},
	 color3[]={0.0,1.0,1.0,0.3,0.5},
	 color4[]={1.0,0.0,0.0,0.3,0.5},
	 color5[]={0.0,0.0,1.0,0.3,0.5},
	 color6[]={0.0,0.0,1.0,0.3,0.5},
	 color7[]={0.0,1.0,0.0,0.3,0.5};


  int i;


  glNewList (EJES,GL_COMPILE);    

  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color3);
  

  glBegin(GL_LINES);{
    glColor3f(1,1,1);
    glVertex3f( 0, 0, 0 );
    glVertex3f( 0, 300, 0 );
    glVertex3f( 0, 0, 0 );
    glVertex3f( 300, 0, 0 );
    glVertex3f( 0, 0, 0 );
    glVertex3f( 0, 0, 300 );

  }
  glEnd();
  glEndList ();

  

  /*base del brazo*/
  glNewList (BASE,GL_COMPILE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color1);
  
  tubo(3,4,4,Complex);

  glPushMatrix();
  glTranslatef(0,3,0);
  circulo(4,Complex);
  glPopMatrix();
  glPushMatrix();
  glRotatef(180, 0, 0, 1 );
  circulo(4,Complex);
  glPopMatrix();

  glPushMatrix();
  glTranslatef(0,3,0);
  tubo(4,2.5,2.5,Complex);
 
  glTranslatef(0,4,0);
  semiesfera(2.5,Complex);
  glPopMatrix();
  glEndList ();
  /*******/
  glNewList (ANTEBRAZO,GL_COMPILE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color2);
  tubo(10,0.6,0.6,Complex);
  glPushMatrix();
  glTranslatef(0,10+sqrt(pow(1.2,2)-pow(0.6,2)),0);
  esfera(1.2,Complex);
  glPopMatrix();
  glEndList ();
  /**********************/
  glNewList (BRAZO,GL_COMPILE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color2);
  tubo(10,0.6,0.6,Complex);
  glEndList ();
  /*******************/
  glNewList (PINZA,GL_COMPILE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color4);
  glPushMatrix();
  esfera(1.2,Complex);
  glTranslatef(0,sqrt(pow(1.2,2)-pow(1,2)),0);
  tubo(1,1,1,Complex);
  glPushMatrix();
  glTranslatef(-2,1,-1);
  caja(4,0.5,2);
  glPopMatrix();
  glPopMatrix();
  glEndList ();
  /********************/
  glNewList (DEDO,GL_COMPILE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color1);
  glTranslatef(-2,1.5+sqrt(pow(1.2,2)-pow(1,2)),-1);
  caja(0.5,2,2);
  glEndList ();

  /******************/
  glNewList (CAJA,GL_COMPILE); 
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color6);
  glPushMatrix();
  /*le agregamos altura para que llegue al suelo*/
  glTranslatef(0,4.205+sqrt(pow(1.2,2)-pow(1,2)),0);
  glRotatef(-180,1,0,0);
  glTranslatef(-1,-1,-1);
  caja(2,2,2);
  glPopMatrix();
  glEndList ();

  glNewList (CAJA2,GL_COMPILE); 
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color6);
  caja(2,2,2);
  glEndList ();


  glNewList (PAPELERA,GL_COMPILE); 
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color7);
  glPushMatrix(); 
  glTranslatef(0,0,-10.1);
  tubo( 2.5, 4, 4,Complex); 
  glPushMatrix();
  glRotatef(180, 0.0, 0.0, 1.0 );
  circulo(4,Complex);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(0,2.5,0);
  circulo(4,Complex);
  glPopMatrix();

  glPopMatrix();
  glEndList ();

  glNewList (CINTA,GL_COMPILE); 
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,color7);

  glPushMatrix(); 
  glRotatef(90,1,0,0);
  glTranslatef(-10,18.8,0);
 

  
  glPushMatrix();
  tira();
  glRotatef(180, 1.0, 0.0, 0.0 );
  glTranslatef(0,-5,0);
  tira();
  glPopMatrix();
  

  
  glPushMatrix();
  glTranslatef(0,0,3);
  tira();
  glRotatef(180, 1.0, 0.0, 0.0 );
  glTranslatef(0,-5,0);
  tira();
  glPopMatrix();
  

  glTranslatef(0,0,1.5);
  for (i=0;i<11;i++){
    tubo( 5, 1.5, 1.5,Complex);

    glPushMatrix();
    glRotatef(180, 0.0, 0.0, 1.0 );
    circulo(1.5,Complex);
    glPopMatrix();

    glPushMatrix();
    glTranslatef(0,5,0);
    circulo(1.5,Complex);
    glPopMatrix();

    glTranslatef(20,0,0);



  }


  glPopMatrix();
  glEndList ();



}


/* ------------------------------------------------------------------------- */


int main( int argc, char *argv[] )
{
// Inicializa glu y Mesa
   glutInit( &argc, argv );

// Crea una ventana X para la salida grfica
   glutInitWindowPosition( 0, 0 );
   glutInitWindowSize( 300, 300 );
   glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );
   glutCreateWindow("CAD. Practica 2");

  
// Inicializa las funciones de dibujo y cambio de tamao de la ventana X
   glutDisplayFunc( Dibuja );
   glutReshapeFunc( Ventana );


   glutIdleFunc( animacion );

   glutTimerFunc( TIME,animacion2,1 );

// FUNCIONES DE INTERACCIN
 	CreaMenu();
	CreaListas();
  	glutKeyboardFunc(letra);
  	glutSpecialFunc(especial);

   	glutPassiveMotionFunc( RatonMovido );

   glutMainLoop();
   return 0;
}




